// C Source File
// Created 4/24/01; 9:00:32 PM

int check_for_moves(){
	short i,j;
	short min, max;
	short valid = 0;
	
	for (i = 0;i < 9;i++){
		for (j = 0;j < 4;j++){
			if(!banchi[j][i].visible) return 1;
		}
	}
	
	if (piece == RED){
		min = 0;
		max = 6;
	} else {
		min = 7;
		max = 13;
	}
	
	for (i = 0;i < 9;i++){
		for (j = 0;j < 4;j++){
			if(banchi[i][j].piece >= min && banchi[i][j].piece <= max) valid = 1;
		}
	}
	
	if (valid == 1){
		for(i = 0;i < 9;i++){
			for (j = 0;j < 4;j++){
				if(check_valid_move(i,j,i+1,j)) return 1;
				if(check_valid_move(i,j,i-1,j)) return 1;
				if(check_valid_move(i,j,i,j+1)) return 1;
				if(check_valid_move(i,j,i,j-1)) return 1;
			}
		}
	}
	
	return 0;
}

void disp_info(short xplace,short yplace){
	short info_piece;
	short i;
	short num[] = {
		0,1,2,3,4,5,6,0,1,2,3,4,5,6
	};
	SCR_RECT myScr = {{0,92,120,100}};
	char * info[14] = {
		"Red Cannon",
		"Red Pawn",
		"Red Horse",
		"Red Cart",
		"Red Elephant",
		"Red Guard",
		"Red King",
		"Black Cannon",
		"Black Pawn",
		"Black Horse",
		"Black Cart",
		"Black Elephant",
		"Black Guard",
		"Black King"
	};

	FontSetSys(F_4x6);
	
	SetCurClip(&myScr);
	
	FontSetSys(F_4x6);
	
	if (banchi[xplace][yplace].piece != EMPTY && banchi[xplace][yplace].visible == VISIBLE){
		info_piece = banchi[xplace][yplace].piece;
		for (i = 0;i < 2;i++){
			SetPlane(i);
			ScrRectFill (&myScr,&myScr,A_REVERSE);
			printf_xy(0,94,"Piece: %s [%d]",info[info_piece], num[info_piece]);
		}
	} else {
		for (i = 0;i < 2;i++){
			SetPlane(i);
			ScrRectFill (&myScr,&myScr,A_REVERSE);
		}		
	}
}

int check_valid_move(short xa,short ya,short xa2,short ya2){
	/***************************
		Red							Black
	0	=	Cannon			7	=	Cannon
	1	=	Pawn				8	=	Pawn
	2	=	Horse				9	=	Horse
	3	=	Cart				10=	Cart
	4	=	Elephant		11=	Elephant
	5	=	Guard				12=	Guard
	6	=	King				13=	King
	***************************/
	short i;
	short loc1=0;
	short loc2=0;
	short valid = 0;
	short xdir=0,ydir=0;
	short array_valid_moves[14][14] = {
				  /*0,1,2,3,4,5,6,7,8,9,10,11,12,13*/
	{		/*0*/	0,0,0,0,0,0,0,1,1,1,1,1,1,1
	},{	/*1*/	0,0,0,0,0,0,0,0,1,0,0,0,0,1
	},{	/*2*/	0,0,0,0,0,0,0,1,1,1,0,0,0,0
	},{	/*3*/	0,0,0,0,0,0,0,1,1,1,1,0,0,0
	},{	/*4*/	0,0,0,0,0,0,0,1,1,1,1,1,0,0
	},{	/*5*/	0,0,0,0,0,0,0,1,1,1,1,1,1,0
	},{	/*6*/	0,0,0,0,0,0,0,1,0,1,1,1,1,1
	},{	/*7*/	1,1,1,1,1,1,1,0,0,0,0,0,0,0
	},{	/*8*/	0,1,0,0,0,0,1,0,0,0,0,0,0,0
	},{	/*9*/	1,1,1,0,0,0,0,0,0,0,0,0,0,0
	},{	/*10*/1,1,1,1,0,0,0,0,0,0,0,0,0,0
	},{	/*11*/1,1,1,1,1,0,0,0,0,0,0,0,0,0
	},{	/*12*/1,1,1,1,1,1,0,0,0,0,0,0,0,0
	},{	/*13*/1,1,1,1,1,1,0,0,0,0,0,0,0,0
	}};

	/*****************************************************************************
	**loads the piece number of the selected piece (loc1) and the victim (loc2)***
	*****************************************************************************/
	
	if (xa == xa2){
		valid = 1;
	} else if (ya == ya2){
		valid = 1;
	} else {
		return 0;
	}
	
	loc1 = banchi[xa2][ya2].piece;
	loc2 = banchi[xa][ya].piece;
	
	/*********************************************
	**Starts to check whether the piece is valid**
	*********************************************/
	
	valid = array_valid_moves[loc1][loc2];
	
	if(loc1 == RED_CANNON || loc1 == BLACK_CANNON){
		valid = 0;
	}
	
	if (valid == 1 || loc2 == EMPTY){
		valid = 0;
		ydir = 0;
		xdir = 0;
		
		if (ya == ya2){
			valid++;
			if (xa2 < xa){
				xdir = 1;
			} else {
				xdir = -1;
			}
		}
		
		if (xa == xa2){
			valid++;
			if (ya2 < ya){
				ydir = 1;
			} else {
				ydir = -1;
			}
		}
	}

	/********************************************************************
	*******checks to see of the piece other than a cannon is valid******* 
	********************************************************************/
	
	if (valid == 1){
		if ((ydir != 0 && ya2 + ydir == ya) || (xdir != 0 && xa2 + xdir == xa)){
			return 1;
		} else {
			return 0;
		}
	}

	/********************************************************************
	*******checks to see if the given movement of a cannon is valid******
	********************************************************************/
	valid = array_valid_moves[loc1][loc2];
	
	if (valid == 1 && (loc1 == 0 || loc1 == 7)){
		valid = 0;
		if (xa == xa2){//if the difference is in the y direction
			if (ya2 < ya){
				ydir = 1;
			} else {
				ydir = -1;
			}
			for (i = ya2 + ydir;i != ya;i += ydir){
				if (banchi[xa][i].piece != EMPTY){
					valid++;
				}
			}
		} else {//if the difference is in the x direction
			if (xa2 < xa){
				xdir = 1;
			} else {
				xdir = -1;
			}
			for (i = xa2 + xdir;i != xa;i += xdir){
				if (banchi[i][ya].piece != EMPTY){
					valid++;
				}
			}
		}
	}

return valid;
}

void move_piece(short xa,short ya,short qxa,short qya,short qxa2,short qya2){
	short piece;
	
	/*
	xa		=	x of superior piece
	ya		=	y of superior piece
	qxa		=	x position in final_array of superior piece
	qya		=	y position in final_array of superior piece
	xa2		=	x of doomed piece
	ya2		=	y of doomed piece
	qxa2	=	x position in final_array of doomed piece
	qya2	=	y position in final_array of doomed piece	
	*/
	
	piece = banchi[qxa2][qya2].piece * 16;

	Sprite16(xa,ya,16,&tiles[0][piece],GetPlane(1),SPRT_XOR);
	Sprite16(xa,ya,16,&tiles[1][piece],GetPlane(0),SPRT_XOR);
	
	banchi[qxa][qya].piece = banchi[qxa2][qya2].piece;
	banchi[qxa2][qya2].piece = EMPTY;
}
