// C Source File
// Created 2/4/01; 6:42:07 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

#define TI89_VERSION 1 //set to 1 to compile for the TI-89
#define debug	0

#if TI89_VERSION
	short _ti89;                  // Produce .89Z File
#else
	short _ti92plus;              // Produce .9XZ File
#endif

//prototypes

int center(char * str,short font);
int Q89_92(short val89,short val92);
int menu(char * title,char * subjects[],short length);
int vCenter(short length,short distance,short number);
int message(char * title,char * messages[],short length,char restore);
int	moveCursor(short xp,short yp,char dir);
int check_valid_move(short xa,short ya,short xa2,short ya2);
int check_for_moves();

short keyHandler();
char keyread(char oi);

void score_board(short num);
void turn_piece_over(short xp,short yp,short xp2,short yp2);
void move_piece(short xa,short ya,short qxa,short qya,short qxa2,short qya2);
void disp_info(short xplace,short yplace);

void rand_place();
void build_board();
void fill_board_w_blanks();

//global variable

//short final_array[9][4] = {};
//short visible_pieces[9][4];
short sec_push = 0;
short dispTime = 0;

struct BANCHI {
	unsigned int visible:1,color:1,piece:4;
} banchi[9][4];

//char Turn = 'r';

//some enumerations
enum{RED_CANNON,RED_PAUN,RED_HORSE,RED_CART,RED_ELEPHANT,RED_GUARD,RED_KING,BLACK_CANNON,BLACK_PAUN,BLACK_HORSE,BLACK_CART,BLACK_ELEPHANT,BLACK_GUARD,BLACK_KING,EMPTY};
enum{RED,BLACK};
enum{INVISIBLE,VISIBLE};

//some defines
#define VERSION 			"Banchi v0.98"
#define XSTART 				7
#define YSTART				0
#define XEND					XSTART + 160
#define YEND					YSTART + 80

#if TI89_VERSION
	#define LEFT_KEY 			_rowread(0xFFFE)&2
	#define RIGHT_KEY 		_rowread(0xFFFE)&8
	#define UP_KEY 				_rowread(0xFFFE)&1
	#define DOWN_KEY 			_rowread(0xFFFE)&4
	#define SECOND_KEY 		_rowread(0xFFFE)&16
	#define	DIAMOND_KEY		_rowread(0xFFFE)&64
	#define ESC_KEY 			_rowread(0xFFBF)&1
	#define PLUS 					_rowread(0xfffd)&2
	#define MINUS 				_rowread(0xfffd)&4
#else
	#define SECOND_KEY 		_rowread(0xfffe)&1
	#define DIAMOND_KEY 	_rowread(0xfffe)&4
	#define LEFT_KEY 			_rowread(0xfffe)&16
	#define UP_KEY 				_rowread(0xfffe)&32
	#define RIGHT_KEY 		_rowread(0xfffe)&64
	#define DOWN_KEY 			_rowread(0xfffe)&128
	#define ESC_KEY 			_rowread(0xfeff)& 64
	#define PLUS		 			_rowread(0xfeff)&16
	#define MINUS 				_rowread(0xfdff)&1
#endif

//the sprites -- created with ImageStudio and TTTiler
#include "sprites.h"
	
//external files
#include "clock.h"
#include "dialog.h"
#include "gui.h"
#include "interrupt.h"
#include "ai.h"

/*****************************************************************************/
/*Main Function*/

int _main()
{
	char*	text1 = VERSION;
	char* text2 = "by: Taylor Southwick";
	char * subjects[] = {"Play","Load","About","Quit"};
	char * messages[] = {VERSION,"","by: Taylor Southwick",""};
	char * messages2[] = {"","","Not implemented yet...","",""};
	char *winner = "       \0";
	char *game = "GAME OVER!";
	char *key = "Press Any Key To Quit";
	char disp[30];
	short chose,i,j;
	
	INT_HANDLER oldint1;
	
	oldint1 = GetIntVec(AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	
	oldint5 = GetIntVec(AUTO_INT_5);
  SetIntVec(AUTO_INT_5, myint5handler);
	
	if (!GrayMode(GRAY_ON)) return;

mennu:
	resettime = 1;
	running = 0;
	dispTime = 0;

	for (i = 0;i < 4;i ++){
		for (j = 0;j < 9;j++){
#if debug
			banchi[j][i].visible = VISIBLE;
#else
			banchi[j][i].visible = INVISIBLE;
#endif
		}
	}
	
	sec_push = 0;
	
	for (i = 0;i < 2; i++){
		SetPlane(i);
		ClrScr();
		FontSetSys(F_8x10);
		DrawStr(center(text1,F_8x10),2,text1,A_NORMAL);
		FontSetSys(F_6x8);
		DrawStr(center(text2,F_6x8),Q89_92(90,115),text2,A_NORMAL);
	}	
	
	chose = menu("Menu",subjects,4);
	
	if (chose == 3){
		message("About",messages,4,'n');
		goto mennu;
	}

	if (chose == 2){
		message("Sorry!",messages2,5,'n');
		goto mennu;
	}

	if (chose == 1){
		for (i = 0;i < 2;i++){
			SetPlane(i);
			ClrScr();
		}
		for (i = 1;i < 3;i++){
			score_board(i);
		}
		rand_place();//ranodmize the locations twice; some bug makes this have to occur		
		fill_board_w_blanks();//puts blanks on the board
		build_board();//builds the boardd
		if (!keyHandler()){//handles the key presses
			if(piece == RED){
				winner = "Red";
			} else {
				winner = "Black";
			}
	
			sprintf(disp,"%s Won!",winner);
			
			SetIntVec(AUTO_INT_1, oldint1);
			
			for (i = 0;i < 2;i++){
				SetPlane(i);
				ClrScr();
				FontSetSys(F_8x10);
				printf_xy(center(game,F_8x10),0,game,A_NORMAL);
				FontSetSys(F_6x8);
				printf_xy(center(disp,F_6x8),20,disp,A_NORMAL);
				FontSetSys(F_4x6);
				printf_xy(center(key,F_4x6),94,key,A_NORMAL);
			}
			
			ngetchx();
			
			oldint1 = GetIntVec(AUTO_INT_1);
			SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
		}
		goto mennu;//redos the loop w/ the main menu
	}
	
	GrayMode(GRAY_OFF);
	SetIntVec(AUTO_INT_1, oldint1);
	SetIntVec(AUTO_INT_5, oldint5);
}

int vCenter(short length,short distance,short number)
{
	return ((LCD_HEIGHT / 2 - (length * (distance / 2))) + (distance * number)) + 8;
}

int center(char *str,short font)
{
	return (160-DrawStrWidth(str,font))/2;
}

int Q89_92(short val89,short val92)
{
	return TI92PLUS?val92:val89;
}
