/*
This routine is taken from Thomas Nussbaumer's Mahjjong Game
*/

INT_HANDLER oldint5 = NULL;  // will hold the address of the previous handler later

volatile short 		mseconds50[2] = {0,0}; // counts in 50ms steps (not exact 50ms, but 1000/19 ms)
volatile short 		seconds[2] = {0,0}; // counts seconds
volatile short 		minutes[2] = {0,0}; // counts minutes
volatile short 		hours[2]   = {0,0}; // counts hours
volatile short 		resettime  = 1; // used to signal a reset clock
volatile short 		running    = 1;
volatile short 		outputtime = 0;
volatile short 		piece			 = 1;
short thex,they;
SCR_RECT plotA;
char bufferForString[30];

/*===========================================================================*/
/* our own interrupt handler hooked on interrupt 5 (updates clock variables) */
/*===========================================================================*/
DEFINE_INT_HANDLER (myint5handler) {
  if (resettime) {
    mseconds50[0]=seconds[0]=minutes[0]=hours[0]=resettime=0;
    mseconds50[0]=seconds[1]=minutes[1]=hours[1]=resettime=0;
    resettime = 0;
  } else if (running) {
    mseconds50[piece]++;
    if (mseconds50[piece] == 19) {
      mseconds50[piece] = 0;
      seconds[piece]++;

      //-------------------------------------------------------
      // we have counted a second, let's update the time output
      // (done within the GetUserInput() routine)
      //-------------------------------------------------------
 
      outputtime=1;

      if (seconds[piece] == 60) {
        seconds[piece] = 0;
        minutes[piece]++;
        if (minutes[piece] == 60) {
          minutes[piece] = 0;
          hours[piece]++;
          if (hours[piece] == 24) hours[piece] = 0;
        }
      }
	
			if (dispTime){
				if (piece == RED){
					thex = XSTART + 1;
				} else {
					thex = XEND - 51 - 15;
				}
	
				they = YEND + 2;
				sprintf(bufferForString,"%02d:%02d:%02d", hours[piece], minutes[piece], seconds[piece]);
			
				FontSetSys(F_6x8);
			
				plotA = (SCR_RECT){{thex,they,thex+47,they+8}};
				
				SetPlane(0);
					ScrRectFill(&plotA,&plotA,A_REVERSE);
					DrawStr(thex,they,bufferForString,A_NORMAL);
				SetPlane(1);
					ScrRectFill(&plotA,&plotA,A_REVERSE);
					DrawStr(thex,they,bufferForString,A_NORMAL);
			}
    }
  }

  //---------------------------------------------------------
  // execute the old interrupt handler at the end of our own
  // to make sure that other timers which are generated using
  // the AMS timer routines like OSRegisterTimer() will still
  // work correctly
  //---------------------------------------------------------

  ExecuteHandler(oldint5);
}
